/*  smdm_config.h -- config file for debug_malloc
 *  Thomas Padron-McCarthy (padrone@lysator.liu.se), 1992
 *  Latest change of this file: Oct 3, 1992
 *
 *  This file, "config_malloc.h", is part of the safe_malloc/debug_malloc
 *  (SM/DM) package for malloc debugging.
 *
 */

#define DEBUG_MALLOC_VERSION	"0.4 (Oct 3, 1992)"

/* Use this instead of size_t, since we don't know where they define size_t: */
typedef unsigned int SIZE_T;

#ifndef NULL
#   define NULL		0
#endif

/*  All memory blocks allocated by malloc should be on addresses
 *  evenly dividable by the ALIGNMENT_FACTOR.
 */

#define ALIGNMENT_FACTOR	4

/*  If you're on a system with 16 bit ints, a 64K variable size limit
 *  and a 640K total process size limit, define this:
 */

/* #define MSDOS */

#ifdef __TURBOC__
#   ifndef MSDOS
#       define MSDOS
#   endif
#endif

/*  Define USE_STANDARD_MALLOC if you want to call the standard "malloc".
 *  This means that "debug_malloc" etc will work as a "wrapper" around
 *  the standard malloc, and that you don't have any control at all over
 *  calls made directly to malloc, for example from within libraries.
 *  If you DON'T #define USE_STANDARD_MALLOC, the "debug_malloc" package
 *  will use it's own simple malloc, which allocates memory from a big
 *  buffer. This is of course slightly wasteful.
 */

/* #define USE_STANDARD_MALLOC */

/*  MAX_MALLOC_SIZE is the absoulte max size of a single allocated area.
 *  Don't touch these!
 */

#ifdef MSDOS
#   define MAX_MALLOC_SIZE		(unsigned long int)65535L
#else
#   define MAX_MALLOC_SIZE		(unsigned long int)2147483647L
#endif

/*---------------------------------------------------------------------------*/

/* This is some other configuration info that you might want to change: */

#define GUARD_BYTE			71	/* 71 decimal = 47 hex = 'G' */
#define FILL_NEW_BYTE			78	/* 78 decimal = 4e hex = 'N' */
#define FILL_FREED_BYTE			70	/* 70 decimal = 46 hex = 'F' */
#define DEFAULT_DUMP_FILE_NAME		"malloc.dmp"
#define DEFAULT_PRINT_CHARACTER		'?'
#define DEFAULT_MAX_PRINT_LENGTH	30
#define HASH_TABLE_SIZE			2213	/* Should always be a prime */

/*  If you don't use the standard malloc, this tells you how big the
 *  buffer, from which we allocate space, should be.
 */

#define MALLOC_BUFFER_SIZE		3000000
/* #define MSDOS_MALLOC_BUFFER_SIZE	65535	-- 64K-1 */
#define MSDOS_MALLOC_BUFFER_SIZE	65000
#define NR_MSDOS_MALLOC_BUFFERS		1	/* Also hard-coded! */
